/**
SAL - Simple Ajax Lib. 23-Sep-2005
by Nigel Liefrink
Email: leafrink@hotmail.com
*/

var debug = false;
/**
Browser Compatability function.
Returns the correct XMLHttpRequest depending on the current browser.
*/
function GetXmlHttp() {	
	var xmlhttp = false;
	if (window.XMLHttpRequest)
	{
		xmlhttp = new XMLHttpRequest();
	}
	else if (window.ActiveXObject) { // code for IE
		try {
			xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
		} 
		catch (e) {
			try {
				xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
			}
			catch (E) {
				xmlhttp = false;
			}
		}
	}
	return xmlhttp;
}


/**
<summary>
Gets the response stream from the passed url, and then calls the callbackFuntion passing the response and the div_ids.
</summary>
<param name="url">The url to make the request to get the response data.</param>
<param name="callbackFunction">The function to call after the response has been recieved. the response <b>must</b> always be the first argument to the function.</param>
<param name="params"> (optional) Any other parameters you want to pass to the functions. (Note: only constants/strings/globals can be passed as params, most variables will be out of scope.) </param>
</summary>
<example>
	<code>
PassAjaxResponseToFunction('?getsomehtml=1', 'FunctionToHandleTheResponse', "\'div1\',\'div2\',\'div3\'");

function FunctionToHandleTheResponse(response, d1, d2, d3){
	var data = response.split(';');
	document.getElementById(d1).innerHTML = data[0];
	document.getElementById(d2).innerHTML = data[1];
	document.getElementById(d3).innerHTML = data[2];
}
	</code>
</example>
*/
/*   ? 
function MemoryLeakingPassAjaxResponseToFunction(url, callbackFunction, params)
{		
	var xmlhttp = new GetXmlHttp();
	//now we got the XmlHttpRequest object, send the request.
	if (xmlhttp)
	{
		xmlhttp.open("GET", url, true);
		xmlhttp.onreadystatechange =
			function ()
			{
				if (xmlhttp && xmlhttp.readyState==4)
				{ //we got something back..
					if (xmlhttp.status == 200)
					{
						var response = rus_unescape(xmlhttp.responseText);
						var functionToCall = callbackFunction + "(response";
						functionToCall += ((params) ? (", " + params + ")") : ")");
						if (debug)
						{
							alert(response);
							alert (functionToCall);
						}
						eval(functionToCall);
					}
					else if (debug) {
						document.write(xmlhttp.responseText);
					}
				}
			}
		xmlhttp.send(null);
	}
}
*/

function PassAjaxResponseToFunction(url, callbackFunction, params, onError) {		
	var xmlhttp = new GetXmlHttp();
	if (xmlhttp) {
		var timeout;
		try {
			xmlhttp.open("GET", url, true);
			xmlhttp.send(null);
			xmlhttp.onreadystatechange = function () {
				var run = false;
				try {
					if (xmlhttp && xmlhttp.readyState==4) {
						clearTimeout(timeout);
						if (xmlhttp.status == 200) {
							var response = rus_unescape(xmlhttp.responseText);
							xmlhttp = null; // memleak fix
							var functionToCall = callbackFunction + "(response";
							functionToCall += ((params) ? (", " + params + ")") : ")");
							if (debug) {
								alert(response);
								alert(functionToCall);
							}
							run = true;
							clearTimeout(timeout);
							eval(functionToCall);
						} else {
							if (debug)
								document.write(xmlhttp.responseText);
							//alert('error');
							if (onError) {
								xmlhttp = null;
								run = true;
								clearTimeout(timeout);
								onError();
							}
						}
					}
				} catch (err) {
					//alert('error 1: ' + err);
					if (!run) {
						clearTimeout(timeout);
						timeout = resetCallback(callbackFunction, 5000);
					}
				}
			};
		} catch (err) {
			//alert('error 2: ' + err);
		}
		timeout = resetCallback(callbackFunction, 15000);
	}
}

function resetCallback(callbackFunction, t) {
	return setTimeout(function () { 
		try {
			if (xmlhttp)
				xmlhttp.abort(); 
		} catch (err) {
			//alert('error 3: ' + err);
		}
		xmlhttp = null;
		var functionToCall = callbackFunction + "()";
		eval(functionToCall);
	}, t);
}


/**
///<summary>
///Sets the innerHTML property of obj_id with the response from the passed url./
///</summary>
///<param name="url">The url to make the request to get the response data.</param>
///<param name="obj_id">The object or the id of the object to set the innerHTML for.</param>
*/
function SetInnerHTMLFromAjaxResponse(url, obj_id, callbackFunction, bappend)
{		
	bappend = (bappend == null) ? false : bappend;
	var xmlhttp = new GetXmlHttp();
	// now we got the XmlHttpRequest object, send the request.
	if (xmlhttp)
	{
		xmlhttp.open("GET", url, false);
		xmlhttp.onreadystatechange =
			function () 
				{
					if (xmlhttp && xmlhttp.readyState==4)
					{ //we got something back..
						if (xmlhttp.status==200)
						{
							if (debug) {
								alert(rus_unescape(xmlhttp.responseText));
							}
							if (typeof obj_id == 'object')
							{
								obj_id.innerHTML = ((bappend)?obj_id.innerHTML:"") +
									rus_unescape(xmlhttp.responseText);
								if (callbackFunction != null) {
									eval(callbackFunction);
								}
							}
							else {
								obj_id = document.getElementById(obj_id);
								obj_id.innerHTML =
									((bappend)?obj_id.innerHTML:"") +
									rus_unescape(xmlhttp.responseText);
								if (callbackFunction != null) {
									eval(callbackFunction);
								}
							}
						}
						else if (debug) {
							document.Write(xmlhttp.responseText);
						}
					}
				}
		xmlhttp.send(null);
	}
}

/*   ? 
function PassAjaxResponseToMethod(url, obj_id, method)
{		
	var xmlhttp = new GetXmlHttp();
	// now we got the XmlHttpRequest object, send the request.
	if (xmlhttp)
	{
		xmlhttp.onreadystatechange =
			function () 
				{
					if (xmlhttp && xmlhttp.readyState==4)
					{ //we got something back..
						if (xmlhttp.status==200)
						{
							var response = rus_unescape(xmlhttp.responseText);
							if (debug) {
								alert(response);
							}
							
							var callinstruction;
							if (typeof obj_id == 'object')
							{
								 callinstruction =
									"obj_id." +
									method + "(response);";
								eval(callinstruction);
							}
							else {
								callinstruction =
									"document.getElementById(obj_id)." +
									method + "(response);";
								eval(callinstruction);
							}
						}
					}
				}
		xmlhttp.open("GET", url, false);
		xmlhttp.send(null);
	}
}
*/
function rus_unescape(str) 
{ 
	str = unescape(str);
	var res = '';
	var s0 =
		"\xB9\xC0\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB" +
		"\xCC\xCD\xCE\xCF\xD0\xD1\xD2\xD3\xD4\xD5\xD6\xD7\xD8" +
		"\xD9\xDA\xDB\xDC\xDD\xDE\xDF\xE0\xE1\xE2\xE3\xE4\xE5" +
		"\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\xF0\xF1\xF2" +
		"\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\xFD\xFE\xFF" +
		"+";
	var s1 = " ";
	for (var i = 0; i < str.length; i++) {
		var ch = str.substring(i, i+1);
		var och = ch;
		var ind = s0.indexOf(ch);
		if (ind >= 0)
			ch = s1.substring(ind, ind + 1);
		res += ch;
	}
	return res;
} 



